diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/wifi/test/wifi-emlsr-test.cc ns-3.41/src/wifi/test/wifi-emlsr-test.cc
--- ns-3.40/src/wifi/test/wifi-emlsr-test.cc	2023-09-27 13:30:37.922839900 -0700
+++ ns-3.41/src/wifi/test/wifi-emlsr-test.cc	2024-02-09 14:44:08.613795300 -0800
@@ -2625,96 +2252,881 @@
     Simulator::Destroy();
 }
 
-/**
- * \ingroup wifi-test
- * \ingroup tests
- *
- * \brief Test the switching of PHYs on EMLSR clients.
- *
- * An AP MLD and an EMLSR client setup 3 links, on which EMLSR mode is enabled. The AP MLD
- * transmits 4 QoS data frames (one after another, each protected by ICF):
- *
- * - the first one on the link used for ML setup, hence no PHY switch occurs
- * - the second one on another link, thus causing the main PHY to switch link
- * - the third one on the remaining link, thus causing the main PHY to switch link again
- * - the fourth one on the link used for ML setup; if the aux PHYs switches link, there is
- *   one aux PHY listening on such a link and the main PHY switches to this link, otherwise
- *   no PHY is listening on such a link and there is no response to the ICF sent by the AP MLD
- */
-class EmlsrLinkSwitchTest : public EmlsrOperationsTestBase
+EmlsrUlTxopTest::EmlsrUlTxopTest(const Params& params)
+    : EmlsrOperationsTestBase("Check EML UL TXOP transmissions"),
+      m_emlsrLinks(params.linksToEnableEmlsrOn),
+      m_channelWidth(params.channelWidth),
+      m_auxPhyChannelWidth(params.auxPhyChannelWidth),
+      m_mediumSyncDuration(params.mediumSyncDuration),
+      m_msdMaxNTxops(params.msdMaxNTxops),
+      m_emlsrEnabledTime(0),
+      m_firstUlPktsGenTime(0),
+      m_unblockMainPhyLinkDelay(MilliSeconds(20)),
+      m_checkBackoffStarted(false),
+      m_countQoSframes(0),
+      m_countBlockAck(0),
+      m_countRtsframes(0),
+      m_genBackoffIfTxopWithoutTx(params.genBackoffIfTxopWithoutTx)
 {
-  public:
-    /**
-     * Constructor
-     *
-     * \param switchAuxPhy whether AUX PHY should switch channel to operate on the link on which
-                          the Main PHY was operating before moving to the link of the Aux PHY
-     * \param resetCamState whether to reset the state of the ChannelAccessManager associated with
-                            the link on which the main PHY has just switched to
-        \param auxPhyMaxChWidth max channel width (MHz) supported by aux PHYs
-     */
-    EmlsrLinkSwitchTest(bool switchAuxPhy, bool resetCamState, uint16_t auxPhyMaxChWidth);
+    m_nEmlsrStations = 1;
+    m_nNonEmlsrStations = 0;
+    m_linksToEnableEmlsrOn = params.linksToEnableEmlsrOn;
+    m_mainPhyId = 1;
+
+    // when aux PHYs do not switch link, the main PHY switches back to its previous link after
+    // a TXOP, hence the transition delay must exceed the channel switch delay (default: 250us)
+    m_transitionDelay = {MicroSeconds(256)};
+    m_establishBaDl = true;
+    m_establishBaUl = true;
+    m_duration = Seconds(1);
 
-    ~EmlsrLinkSwitchTest() override = default;
+    NS_ABORT_MSG_IF(params.linksToEnableEmlsrOn.size() < 2,
+                    "This test requires at least two links to be configured as EMLSR links");
+    for (uint8_t id = 0; id < 3; id++)
+    {
+        if (m_emlsrLinks.count(id) == 0)
+        {
+            // non-EMLSR link found
+            m_nonEmlsrLink = id;
+            break;
+        }
+    }
+}
 
-  protected:
-    void DoSetup() override;
-    void DoRun() override;
-    void Transmit(Ptr<WifiMac> mac,
-                  uint8_t phyId,
-                  WifiConstPsduMap psduMap,
-                  WifiTxVector txVector,
-                  double txPowerW) override;
+void
+EmlsrUlTxopTest::DoSetup()
+{
+    Config::SetDefault("ns3::EmlsrManager::AuxPhyChannelWidth",
+                       UintegerValue(m_auxPhyChannelWidth));
+    Config::SetDefault("ns3::DefaultEmlsrManager::SwitchAuxPhy", BooleanValue(false));
+    Config::SetDefault("ns3::EhtConfiguration::MediumSyncDuration",
+                       TimeValue(m_mediumSyncDuration));
+    Config::SetDefault("ns3::EhtConfiguration::MsdMaxNTxops", UintegerValue(m_msdMaxNTxops));
+    Config::SetDefault("ns3::ChannelAccessManager::GenerateBackoffIfTxopWithoutTx",
+                       BooleanValue(m_genBackoffIfTxopWithoutTx));
+    // Channel switch delay should be less than RTS TX time + SIFS + CTS TX time, otherwise
+    // UL TXOPs cannot be initiated by aux PHYs
+    Config::SetDefault("ns3::WifiPhy::ChannelSwitchDelay", TimeValue(MicroSeconds(75)));
 
-    /**
-     * Check that the simulation produced the expected results.
-     */
-    void CheckResults();
+    EmlsrOperationsTestBase::DoSetup();
 
-    /**
-     * Check that the Main PHY (and possibly the Aux PHY) correctly switches channel when the
-     * reception of an ICF ends.
-     *
-     * \param psduMap the PSDU carrying the MU-RTS TF
-     * \param txVector the TXVECTOR used to send the PPDU
-     * \param linkId the ID of the given link
-     */
-    void CheckInitialControlFrame(const WifiConstPsduMap& psduMap,
-                                  const WifiTxVector& txVector,
-                                  uint8_t linkId);
+    m_staMacs[0]->GetQosTxop(AC_BE)->TraceConnectWithoutContext(
+        "BackoffTrace",
+        MakeCallback(&EmlsrUlTxopTest::BackoffGenerated, this));
+
+    uint8_t linkId = 0;
+    // configure channels of the given width
+    for (auto band : {WIFI_PHY_BAND_2_4GHZ, WIFI_PHY_BAND_5GHZ, WIFI_PHY_BAND_6GHZ})
+    {
+        uint16_t bw = 20;
+        uint8_t number = band == WIFI_PHY_BAND_5GHZ ? 36 : 1;
+
+        auto width = std::min<uint16_t>(m_channelWidth, band == WIFI_PHY_BAND_2_4GHZ ? 40 : 160);
+        while (bw < width)
+        {
+            bw *= 2;
+            number += bw / 20;
+        }
+
+        for (auto mac : std::initializer_list<Ptr<WifiMac>>{m_apMac, m_staMacs[0]})
+        {
+            mac->GetWifiPhy(linkId)->SetOperatingChannel(
+                WifiPhy::ChannelTuple{number, width, band, 0});
+        }
+        linkId++;
+    }
+
+    // install post reception error model on the AP affiliated with the AP MLD and operating on
+    // the same link as the main PHY of the EMLSR client
+    m_errorModel = CreateObject<ListErrorModel>();
+    m_apMac->GetWifiPhy(m_mainPhyId)->SetPostReceptionErrorModel(m_errorModel);
+}
+
+void
+EmlsrUlTxopTest::BackoffGenerated(uint32_t backoff, uint8_t linkId)
+{
+    NS_LOG_INFO("Backoff value " << backoff << " generated by EMLSR client on link " << +linkId
+                                 << "\n");
+    if (linkId != m_mainPhyId)
+    {
+        return; // we are only interested in backoff on main PHY link
+    }
+
+    if (m_backoffEndTime)
+    {
+        if (m_checkBackoffStarted)
+        {
+            // another backoff value while checkBackoffStarted is true is generated only if
+            // GenerateBackoffIfTxopWithoutTx is true
+            NS_TEST_EXPECT_MSG_EQ(
+                m_genBackoffIfTxopWithoutTx,
+                true,
+                "Another backoff value should not be generated while the main PHY link is blocked");
+
+            NS_TEST_EXPECT_MSG_EQ(m_backoffEndTime.value(),
+                                  Simulator::Now(),
+                                  "Backoff generated at unexpected time");
+        }
+        else
+        {
+            // we are done checking the backoff
+            m_backoffEndTime.reset();
+        }
+    }
+
+    if (m_checkBackoffStarted)
+    {
+        m_backoffEndTime = Simulator::Now() +
+                           m_staMacs[0]->GetChannelAccessManager(linkId)->GetSifs() +
+                           (m_staMacs[0]->GetQosTxop(AC_BE)->GetAifsn(linkId) + backoff) *
+                               m_staMacs[0]->GetChannelAccessManager(linkId)->GetSlot();
+    }
+}
+
+void
+EmlsrUlTxopTest::Transmit(Ptr<WifiMac> mac,
+                          uint8_t phyId,
+                          WifiConstPsduMap psduMap,
+                          WifiTxVector txVector,
+                          double txPowerW)
+{
+    EmlsrOperationsTestBase::Transmit(mac, phyId, psduMap, txVector, txPowerW);
+    auto linkId = m_txPsdus.back().linkId;
+
+    auto psdu = psduMap.begin()->second;
+    auto nodeId = mac->GetDevice()->GetNode()->GetId();
+
+    switch (psdu->GetHeader(0).GetType())
+    {
+    case WIFI_MAC_MGT_ASSOCIATION_REQUEST:
+        NS_ASSERT_MSG(nodeId > 0, "APs do not send AssocReq frames");
+        NS_TEST_EXPECT_MSG_EQ(+linkId, +m_mainPhyId, "AssocReq not sent by the main PHY");
+        break;
+
+    case WIFI_MAC_CTL_RTS:
+        CheckRtsFrames(*psdu->begin(), txVector, linkId);
+        break;
+
+    case WIFI_MAC_CTL_CTS:
+        CheckCtsFrames(*psdu->begin(), txVector, linkId);
+        break;
+
+    case WIFI_MAC_QOSDATA:
+        CheckQosFrames(psduMap, txVector, linkId);
+        break;
+
+    case WIFI_MAC_CTL_BACKRESP:
+        CheckBlockAck(psduMap, txVector, linkId);
+        break;
+
+    default:;
+    }
+}
+
+void
+EmlsrUlTxopTest::StartTraffic()
+{
+    // initially, we prevent transmissions on aux PHY links
+    auto auxPhyLinks = m_staMacs[0]->GetSetupLinkIds();
+    auxPhyLinks.erase(m_mainPhyId);
+    if (m_nonEmlsrLink)
+    {
+        auxPhyLinks.erase(*m_nonEmlsrLink);
+    }
+    m_staMacs[0]->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                        m_apMac->GetAddress(),
+                                        auxPhyLinks);
+
+    // Association, Block Ack agreement establishment and enabling EMLSR mode have been done.
+    // After 50ms, schedule:
+    // - block of transmissions on the link where the main PHY is operating and on the non-EMLSR
+    //   link (if any)
+    // - the generation of two UL packets
+    // - after m_unblockMainPhyLinkDelay, unblock transmissions on the link where the main PHY
+    //   is operating, so that the first data frame is transmitted on that link
+    Simulator::Schedule(MilliSeconds(50), [&]() {
+        std::set<uint8_t> linkIds;
+        linkIds.insert(*m_staMacs[0]->GetLinkForPhy(m_mainPhyId));
+        if (m_nonEmlsrLink)
+        {
+            linkIds.insert(*m_nonEmlsrLink);
+        }
+        m_staMacs[0]->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                            m_apMac->GetAddress(),
+                                            linkIds);
+
+        NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
+        m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
+        m_firstUlPktsGenTime = Simulator::Now();
+
+        Simulator::Schedule(m_unblockMainPhyLinkDelay, [&]() {
+            m_staMacs[0]->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                  m_apMac->GetAddress(),
+                                                  {*m_staMacs[0]->GetLinkForPhy(m_mainPhyId)});
+        });
+    });
+}
+
+void
+EmlsrUlTxopTest::CheckQosFrames(const WifiConstPsduMap& psduMap,
+                                const WifiTxVector& txVector,
+                                uint8_t linkId)
+{
+    m_countQoSframes++;
+
+    auto txDuration =
+        WifiPhy::CalculateTxDuration(psduMap, txVector, m_apMac->GetWifiPhy(linkId)->GetPhyBand());
+
+    switch (m_countQoSframes)
+    {
+    case 1:
+    case 2:
+        // do nothing, these are the QoS data frames sent to establish BA agreements in DL and UL
+        // direction
+        break;
+    case 3:
+        // first UL data frame (transmitted by the main PHY)
+        if (m_nonEmlsrLink)
+        {
+            // generate data packets for another UL data frame, which will be sent on the
+            // non-EMLSR link
+            NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
+            m_staMacs[0]->GetDevice()->GetNode()->AddApplication(
+                GetApplication(UPLINK, 0, 2, 1000));
+
+            // unblock transmissions on the non-EMLSR link once the two packets are queued
+            Simulator::ScheduleNow([=, this]() {
+                m_staMacs[0]->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                      m_apMac->GetAddress(),
+                                                      {*m_nonEmlsrLink});
+            });
+        }
+
+        // check that other EMLSR links are now blocked on the EMLSR client and on the AP MLD
+        // after this QoS data frame is received
+        Simulator::ScheduleNow([=, this]() {
+            for (auto id : m_staMacs[0]->GetLinkIds())
+            {
+                CheckBlockedLink(
+                    m_staMacs[0],
+                    m_apMac->GetAddress(),
+                    id,
+                    WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                    id != m_staMacs[0]->GetLinkForPhy(m_mainPhyId) && m_staMacs[0]->IsEmlsrLink(id),
+                    "Checking EMLSR links on EMLSR client while sending the first data frame",
+                    false);
+
+                Simulator::Schedule(
+                    txDuration + MicroSeconds(1) /* propagation delay */,
+                    [=, this]() {
+                        CheckBlockedLink(
+                            m_apMac,
+                            m_staMacs[0]->GetAddress(),
+                            id,
+                            WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                            id != m_staMacs[0]->GetLinkForPhy(m_mainPhyId) &&
+                                m_staMacs[0]->IsEmlsrLink(id),
+                            "Checking EMLSR links on AP MLD while sending the first data frame");
+                    });
+            }
+        });
+
+        if (m_nonEmlsrLink)
+        {
+            break;
+        }
+        m_countQoSframes++; // if all EMLSR links, next case is already executed now
+        [[fallthrough]];
+    case 4:
+        // check that other EMLSR links are now blocked on the EMLSR client and on the AP MLD
+        // after this QoS data frame is received
+        Simulator::ScheduleNow([=, this]() {
+            // make aux PHYs capable of transmitting frames
+            auto auxPhyLinks = m_staMacs[0]->GetSetupLinkIds();
+            auxPhyLinks.erase(m_mainPhyId);
+            if (m_nonEmlsrLink)
+            {
+                auxPhyLinks.erase(*m_nonEmlsrLink);
+            }
+            m_staMacs[0]->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                  m_apMac->GetAddress(),
+                                                  auxPhyLinks);
+
+            // block transmissions on the link where the main PHY is operating
+            m_staMacs[0]->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                m_apMac->GetAddress(),
+                                                {*m_staMacs[0]->GetLinkForPhy(m_mainPhyId)});
+
+            // generate data packets for another UL data frame, which will be sent on a link on
+            // which an aux PHY is operating
+            NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
+            m_staMacs[0]->GetDevice()->GetNode()->AddApplication(
+                GetApplication(UPLINK, 0, 2, 1000));
+        });
+        break;
+    case 5:
+        // check that other EMLSR links are now blocked on both the EMLSR client and the AP MLD
+        Simulator::ScheduleNow([=, this]() {
+            for (auto id : m_staMacs[0]->GetLinkIds())
+            {
+                CheckBlockedLink(
+                    m_staMacs[0],
+                    m_apMac->GetAddress(),
+                    id,
+                    WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                    id != linkId && m_staMacs[0]->IsEmlsrLink(id),
+                    "Checking EMLSR links on EMLSR client while sending the second data frame",
+                    false);
+
+                CheckBlockedLink(
+                    m_apMac,
+                    m_staMacs[0]->GetAddress(),
+                    id,
+                    WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                    id != linkId && m_staMacs[0]->IsEmlsrLink(id),
+                    "Checking EMLSR links on AP MLD while sending the second data frame",
+                    false);
+            }
+
+            // unblock transmission on the link where the main PHY is operating
+            m_staMacs[0]->GetMacQueueScheduler()->UnblockQueues(
+                WifiQueueBlockedReason::TID_NOT_MAPPED,
+                AC_BE,
+                {WIFI_QOSDATA_QUEUE},
+                m_apMac->GetAddress(),
+                m_staMacs[0]->GetAddress(),
+                {0},
+                {m_mainPhyId});
+        });
+        break;
+    }
+}
+
+void
+EmlsrUlTxopTest::CheckBlockAck(const WifiConstPsduMap& psduMap,
+                               const WifiTxVector& txVector,
+                               uint8_t linkId)
+{
+    m_countBlockAck++;
+
+    auto auxPhyLinks = m_staMacs[0]->GetSetupLinkIds();
+    auxPhyLinks.erase(m_mainPhyId);
+    if (m_nonEmlsrLink)
+    {
+        auxPhyLinks.erase(*m_nonEmlsrLink);
+    }
+
+    // lambda to check that the MediumSyncDelay timer is correctly running/not running and
+    // the CCA ED threshold is set to the correct value on all the links
+    auto checkMediumSyncDelayTimerActive = [=, this]() {
+        for (auto id : m_staMacs[0]->GetLinkIds())
+        {
+            // timer only started on EMLSR links other than the link on which TXOP was carried
+            // out
+            auto isTimerActive = m_staMacs[0]->IsEmlsrLink(id) && id != linkId;
+            auto time = m_staMacs[0]->GetEmlsrManager()->GetElapsedMediumSyncDelayTimer(id);
+            NS_TEST_EXPECT_MSG_EQ(time.has_value(),
+                                  isTimerActive,
+                                  Simulator::Now().As(Time::MS)
+                                      << " Unexpected status for MediumSyncDelay timer on link "
+                                      << +id << " after terminating a TXOP on link " << +linkId);
+            auto currThreshold = m_staMacs[0]->GetWifiPhy(id)->GetCcaEdThreshold();
+            NS_TEST_EXPECT_MSG_EQ((static_cast<int8_t>(currThreshold) ==
+                                   m_staMacs[0]->GetEmlsrManager()->GetMediumSyncOfdmEdThreshold()),
+                                  isTimerActive,
+                                  Simulator::Now().As(Time::MS)
+                                      << " Unexpected value (" << currThreshold
+                                      << ") for CCA ED threshold on link " << +id
+                                      << " when MediumSyncDelay is "
+                                      << (isTimerActive ? "active" : "inactive"));
+        }
+    };
+
+    auto txDuration =
+        WifiPhy::CalculateTxDuration(psduMap, txVector, m_apMac->GetWifiPhy(linkId)->GetPhyBand());
+
+    switch (m_countBlockAck)
+    {
+    case 1:
+    case 2:
+        // do nothing, these are BlockAcks in response to the QoS data frames sent to establish
+        // BA agreements in DL and UL direction
+        break;
+    case 3:
+        if (linkId == m_nonEmlsrLink)
+        {
+            // this BlockAck has been sent on the non-EMLSR link, ignore it
+            break;
+        }
+        m_checkBackoffStarted = true;
+        if (!m_nonEmlsrLink)
+        {
+            m_countBlockAck++; // if all EMLSR links, next case is already executed now
+        }
+        [[fallthrough]];
+    case 4:
+        if (m_nonEmlsrLink && m_countBlockAck == 4)
+        {
+            // block transmissions on the non-EMLSR link
+            Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
+                m_staMacs[0]->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                    m_apMac->GetAddress(),
+                                                    {*m_nonEmlsrLink});
+            });
+        }
+        if (linkId == m_nonEmlsrLink)
+        {
+            // this BlockAck has been sent on the non-EMLSR link, ignore it
+            break;
+        }
+        m_checkBackoffStarted = true;
+        // check MediumSyncDelay timer on the EMLSR client after receiving BlockAck
+        Simulator::Schedule(txDuration + NanoSeconds(1), checkMediumSyncDelayTimerActive);
+        break;
+    case 5:
+        // Block Ack in response to the second data frame sent by the EMLSR client on EMLSR links.
+        // Check that MediumSyncDelay timer is running on the link where the main PHY is operating
+        // and that the number of backoff slots is not changed since the beginning of the TXOP
+        Simulator::Schedule(txDuration + NanoSeconds(1), [=, this]() {
+            checkMediumSyncDelayTimerActive();
+            auto elapsed =
+                m_staMacs[0]->GetEmlsrManager()->GetElapsedMediumSyncDelayTimer(m_mainPhyId);
+            NS_TEST_EXPECT_MSG_EQ(
+                elapsed.has_value(),
+                true,
+                "MediumSyncDelay timer not running on link where main PHY is operating");
+            m_lastMsdExpiryTime = Simulator::Now() +
+                                  m_staMacs[0]->GetEmlsrManager()->GetMediumSyncDuration() -
+                                  *elapsed;
+        });
+
+        Simulator::Schedule(txDuration, [=, this]() {
+            m_checkBackoffStarted = false;
+            NS_TEST_ASSERT_MSG_EQ(m_backoffEndTime.has_value(),
+                                  true,
+                                  "Backoff end time should have been calculated");
+            // when this BlockAck is received, the TXOP ends and the main PHY link is unblocked,
+            // which causes a new backoff timer to be generated if the backoff timer is not
+            // already running
+            *m_backoffEndTime = Max(*m_backoffEndTime, Simulator::Now());
+        });
+
+        // make aux PHYs not capable of transmitting frames
+        m_staMacs[0]->BlockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                            m_apMac->GetAddress(),
+                                            auxPhyLinks);
+
+        // generate data packets for another UL data frame, which will be sent on the link where
+        // the main PHY is operating
+        NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
+        m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
+        break;
+    case 6:
+        // block transmission on the main PHY link and on the non-EMLSR link (if any), so that
+        // the next QoS frames are sent on a link where an aux PHY is operating
+        std::set<uint8_t> linkIds{m_mainPhyId};
+        if (m_nonEmlsrLink)
+        {
+            linkIds.insert(*m_nonEmlsrLink);
+        }
+        m_staMacs[0]->GetMacQueueScheduler()->BlockQueues(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                                          AC_BE,
+                                                          {WIFI_QOSDATA_QUEUE},
+                                                          m_apMac->GetAddress(),
+                                                          m_staMacs[0]->GetAddress(),
+                                                          {0},
+                                                          linkIds);
+        // make sure aux PHYs are capable of transmitting frames
+        m_staMacs[0]->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::TID_NOT_MAPPED,
+                                              m_apMac->GetAddress(),
+                                              auxPhyLinks);
+
+        // generate data packets for another UL data frame
+        NS_LOG_INFO("Enqueuing two packets at the EMLSR client\n");
+        m_staMacs[0]->GetDevice()->GetNode()->AddApplication(GetApplication(UPLINK, 0, 2, 1000));
+
+        break;
+    }
+}
+
+void
+EmlsrUlTxopTest::CheckRtsFrames(Ptr<const WifiMpdu> mpdu,
+                                const WifiTxVector& txVector,
+                                uint8_t linkId)
+{
+    if (m_firstUlPktsGenTime.IsZero())
+    {
+        // this function only considers RTS frames sent after the first QoS data frame
+        return;
+    }
+
+    if (linkId != m_mainPhyId)
+    {
+        if (m_countRtsframes > 0 && !m_corruptCts.has_value())
+        {
+            // we get here for the frame exchange in which the CTS response must be corrupted.
+            // Install post reception error model on the STA affiliated with the EMLSR client that
+            // is transmitting this RTS frame
+            m_errorModel = CreateObject<ListErrorModel>();
+            m_staMacs[0]->GetWifiPhy(linkId)->SetPostReceptionErrorModel(m_errorModel);
+            m_corruptCts = true;
+        }
+
+        return;
+    }
+
+    // we get here for RTS frames sent by the main PHY while the MediumSyncDelay timer is running
+    m_countRtsframes++;
+
+    NS_TEST_EXPECT_MSG_EQ(txVector.GetChannelWidth(),
+                          m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId)->GetChannelWidth(),
+                          "RTS sent by main PHY on an unexpected width");
+
+    // corrupt reception at AP MLD
+    NS_LOG_INFO("CORRUPTED");
+    m_errorModel->SetList({mpdu->GetPacket()->GetUid()});
+}
+
+void
+EmlsrUlTxopTest::CheckCtsFrames(Ptr<const WifiMpdu> mpdu,
+                                const WifiTxVector& txVector,
+                                uint8_t linkId)
+{
+    if (m_corruptCts.has_value() && *m_corruptCts)
+    {
+        // corrupt reception at EMLSR client
+        NS_LOG_INFO("CORRUPTED");
+        m_errorModel->SetList({mpdu->GetPacket()->GetUid()});
+        m_corruptCts = false;
+
+        auto txDuration = WifiPhy::CalculateTxDuration(mpdu->GetSize(),
+                                                       txVector,
+                                                       m_apMac->GetWifiPhy(linkId)->GetPhyBand());
+        // main PHY is about to complete channel switch when CTS ends
+        Simulator::Schedule(txDuration, [=, this]() {
+            const auto mainPhy = m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId);
+            NS_TEST_EXPECT_MSG_EQ(mainPhy->IsStateSwitching(),
+                                  true,
+                                  "Expecting the main PHY to be switching link");
+        });
+    }
+}
+
+void
+EmlsrUlTxopTest::DoRun()
+{
+    Simulator::Stop(m_duration);
+    Simulator::Run();
+
+    CheckResults();
+
+    Simulator::Destroy();
+}
+
+void
+EmlsrUlTxopTest::CheckResults()
+{
+    if (m_msdMaxNTxops > 0)
+    {
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(
+            m_countRtsframes,
+            m_msdMaxNTxops,
+            "Unexpected number of RTS frames sent while the MediumSyncDelay timer is running");
+    }
+
+    auto psduIt = m_txPsdus.cbegin();
+
+    // lambda to jump to the next QoS data frame or MU-RTS Trigger Frame or RTS transmitted
+    // to/by an EMLSR client
+    auto jumpToQosDataOrMuRts = [&]() {
+        while (psduIt != m_txPsdus.cend() &&
+               !psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData() &&
+               !psduIt->psduMap.cbegin()->second->GetHeader(0).IsRts())
+        {
+            auto psdu = psduIt->psduMap.cbegin()->second;
+            if (psdu->GetHeader(0).IsTrigger())
+            {
+                CtrlTriggerHeader trigger;
+                psdu->GetPayload(0)->PeekHeader(trigger);
+                if (trigger.IsMuRts())
+                {
+                    break;
+                }
+            }
+            psduIt++;
+        }
+    };
 
     /**
-     * Check that appropriate actions are taken by the AP MLD transmitting a PPDU containing
-     * QoS data frames to the EMLSR client on the given link.
+     * EMLSR client with EMLSR mode enabled on all links (main PHY ID = 1).
      *
-     * \param psduMap the PSDU(s) carrying QoS data frames
-     * \param txVector the TXVECTOR used to send the PPDU
-     * \param linkId the ID of the given link
-     */
-    void CheckQosFrames(const WifiConstPsduMap& psduMap,
-                        const WifiTxVector& txVector,
-                        uint8_t linkId);
-
-  private:
-    bool m_switchAuxPhy;  /**< whether AUX PHY should switch channel to operate on the link on which
-                               the Main PHY was operating before moving to the link of Aux PHY */
-    bool m_resetCamState; /**< whether to reset the state of the ChannelAccessManager associated
-                               with the link on which the main PHY has just switched to */
-    uint16_t m_auxPhyMaxChWidth;  //!< max channel width (MHz) supported by aux PHYs
-    std::size_t m_countQoSframes; //!< counter for QoS data frames
-    std::size_t m_txPsdusPos;     //!< a position in the vector of TX PSDUs
-};
-
-EmlsrLinkSwitchTest::EmlsrLinkSwitchTest(bool switchAuxPhy,
-                                         bool resetCamState,
-                                         uint16_t auxPhyMaxChWidth)
+     *  main PHY│
+     *  blocked,│
+     *  aux PHYs││main PHY blocked│
+     *  cannot  │
+     *  transmit│
+     *          │                    ┌───┐         ┌──┐
+     *  [link 0]                     │CTS│         │BA│
+     *  ────────────────────────┬───┬┴───┴┬───┬───┬┴──┴─────────────────────────────────────────
+     *                          │RTS│     │QoS│QoS│
+     *                          └───┘     │ 6 │ 7 │
+     *                                    └───┴───┘
+     *                             gen backoff      gen backoff if     MediumSyncDelay
+     *                    ┌──┐    (also many times)  not running       timer expired ┌──┐
+     *  [link 1]          │BA│  │   if allowed        │                   │          │BA│
+     *  ─────────┬───┬───┬┴──┴───────────────────────────┬───┬─────┬───┬────┬───┬───┬┴──┴───────
+     *           │QoS│QoS│                               │RTS│ ... │RTS│    │QoS│QoS│
+     *           │ 4 │ 5 │                               └───┘     └───┘    │ 8 │ 9 │
+     *           └───┴───┘                                                  └───┴───┘
+     *
+     *  [link 2]
+     *  ───────────────────────────────────────────────────────────────────────────
+     *
+     *
+     *
+     * EMLSR client with EMLSR mode enabled on links 0 and 1 (main PHY ID = 1).
+     *
+     * main PHY │
+     *   and    │
+     * non-EMLSR│
+     *   link   │
+     *  blocked,│
+     *  aux PHYs││main PHY blocked│
+     *  cannot  │
+     *  transmit│
+     *          │                    ┌───┐         ┌──┐
+     *  [link 0]                     │CTS│         │BA│
+     *  ────────────────────────┬───┬┴───┴┬───┬───┬┴──┴─────────────────────────────────────────
+     *                          │RTS│     │QoS│QoS│
+     *                          └───┘     │ 8 │ 9 │
+     *                                    └───┴───┘
+     *                             gen backoff      gen backoff if     MediumSyncDelay
+     *                    ┌──┐    (also many times)  not running       timer expired ┌──┐
+     *  [link 1]          │BA│  │   if allowed        │                   │          │BA│
+     *  ─────────┬───┬───┬┴──┴───────────────────────────┬───┬─────┬───┬────┬───┬───┬┴──┴───────
+     *           │QoS│QoS│                               │RTS│ ... │RTS│    │QoS│QoS│
+     *           │ 4 │ 5 │                               └───┘     └───┘    │ 10│ 11│
+     *           └───┴───┘                                                  └───┴───┘
+     *                     ┌──┐
+     *  [link 2]           │BA│
+     *  ──────────┬───┬───┬┴──┴────────────────────────────────────────────────────────────
+     *            │QoS│QoS│
+     *            │ 6 │ 7 │
+     *            └───┴───┘
+     *
+     * For both scenarios, after the last frame exchange on the main PHY link, we have the
+     * following frame exchange on an EMLSR link where an aux PHY is operating on:
+     *
+     *             ┌───┐              ┌───┐         ┌──┐
+     *             │CTS│              │CTS│         │BA│
+     *  ──────┬───┬┴───X─────────┬───┬┴───┴┬───┬───┬┴──┴─────────────────────────────────────
+     *        │RTS│              │RTS│     │QoS│QoS│
+     *        └───┘              └───┘     │ X │ Y │
+     *                                     └───┴───┘
+     * For all EMLSR links scenario, X=10, Y=11; otherwise, X=12, Y=13.
+     */
+
+    // jump to the first (non-Beacon) frame transmitted after establishing BA agreements and
+    // enabling EMLSR mode
+    while (psduIt != m_txPsdus.cend() &&
+           (psduIt->startTx < m_firstUlPktsGenTime ||
+            psduIt->psduMap.cbegin()->second->GetHeader(0).IsBeacon()))
+    {
+        ++psduIt;
+    }
+
+    // the first QoS data frame is transmitted by the main PHY without RTS protection as soon
+    // as transmissions on the link where the main PHY is operating are unblocked (at this
+    // moment, aux PHYs cannot transmit)
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "First QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData(),
+                          true,
+                          "First QoS data frame should be transmitted without protection");
+    NS_TEST_EXPECT_MSG_EQ(+psduIt->phyId,
+                          +m_mainPhyId,
+                          "First QoS data frame should be transmitted by the main PHY");
+    NS_TEST_EXPECT_MSG_GT_OR_EQ(psduIt->startTx,
+                                m_firstUlPktsGenTime + m_unblockMainPhyLinkDelay,
+                                "First QoS data frame sent too early");
+
+    auto prevPsduIt = psduIt++;
+    jumpToQosDataOrMuRts();
+
+    if (m_nonEmlsrLink)
+    {
+        // an additional data frame is sent concurrently on the non-EMLSR link
+        NS_TEST_ASSERT_MSG_EQ(
+            (psduIt != m_txPsdus.cend()),
+            true,
+            "Expected another QoS data frame sent concurrently with the first frame");
+        NS_TEST_EXPECT_MSG_EQ(
+            psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData(),
+            true,
+            "First data frame on non-EMLSR link should be transmitted without protection");
+        NS_TEST_EXPECT_MSG_EQ(+psduIt->linkId,
+                              +m_nonEmlsrLink.value(),
+                              "First data frame expected to be transmitted on the non-EMLSR link");
+        const auto txDuration =
+            WifiPhy::CalculateTxDuration(prevPsduIt->psduMap,
+                                         prevPsduIt->txVector,
+                                         m_staMacs[0]->GetWifiPhy(prevPsduIt->phyId)->GetPhyBand());
+        NS_TEST_EXPECT_MSG_LT(psduIt->startTx,
+                              prevPsduIt->startTx + txDuration,
+                              "First data frame on the non-EMLSR link not sent concurrently");
+        psduIt++;
+        jumpToQosDataOrMuRts();
+    }
+
+    // the second QoS data frame is transmitted by the main PHY after that the aux PHY has
+    // obtained a TXOP and sent an RTS
+    // RTS
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "RTS before second QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsRts(),
+                          true,
+                          "Second QoS data frame should be transmitted with protection");
+    NS_TEST_EXPECT_MSG_NE(
+        +psduIt->phyId,
+        +m_mainPhyId,
+        "RTS before second QoS data frame should not be transmitted by the main PHY");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
+                          m_auxPhyChannelWidth,
+                          "RTS before second data frame transmitted on an unexpected width");
+    psduIt++;
+    // CTS
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "CTS before second QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsCts(),
+                          true,
+                          "CTS before second QoS data frame has not been transmitted");
+    psduIt++;
+    // QoS Data
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "Second QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData(),
+                          true,
+                          "Second QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(+psduIt->phyId,
+                          +m_mainPhyId,
+                          "Second QoS data frame should be transmitted by the main PHY");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
+                          m_auxPhyChannelWidth,
+                          "Second data frame not transmitted on the same width as RTS");
+
+    bool moreQosDataFound = false;
+
+    while (++psduIt != m_txPsdus.cend())
+    {
+        jumpToQosDataOrMuRts();
+        if (psduIt != m_txPsdus.cend() &&
+            psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData())
+        {
+            moreQosDataFound = true;
+
+            NS_TEST_EXPECT_MSG_EQ(+psduIt->phyId,
+                                  +m_mainPhyId,
+                                  "Last QoS data frame should be transmitted by the main PHY");
+            NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
+                                  m_staMacs[0]->GetDevice()->GetPhy(m_mainPhyId)->GetChannelWidth(),
+                                  "Expecting TX width of last data frame to equal the channel "
+                                  "width used by the main PHY");
+            NS_TEST_EXPECT_MSG_GT_OR_EQ(
+                psduIt->startTx,
+                m_lastMsdExpiryTime,
+                "Last QoS data frame sent before MediumSyncDelay timer expired");
+
+            break;
+        }
+    }
+
+    NS_TEST_EXPECT_MSG_EQ(moreQosDataFound,
+                          true,
+                          "Last QoS data frame transmitted by the main PHY not found");
+
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()), true, "Expected more frames");
+    ++psduIt;
+    jumpToQosDataOrMuRts();
+
+    // the first attempt at transmitting the last QoS data frame fails because CTS is corrupted
+    // RTS
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "RTS before last QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsRts(),
+                          true,
+                          "Last QoS data frame should be transmitted with protection");
+    NS_TEST_EXPECT_MSG_NE(
+        +psduIt->phyId,
+        +m_mainPhyId,
+        "RTS before last QoS data frame should not be transmitted by the main PHY");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
+                          m_auxPhyChannelWidth,
+                          "RTS before last data frame transmitted on an unexpected width");
+    psduIt++;
+    // CTS
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "CTS before last QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsCts(),
+                          true,
+                          "CTS before last QoS data frame has not been transmitted");
+    psduIt++;
+    jumpToQosDataOrMuRts();
+
+    // the last QoS data frame is transmitted by an aux PHY after that the aux PHY has
+    // obtained a TXOP and sent an RTS
+    // RTS
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "RTS before last QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsRts(),
+                          true,
+                          "Last QoS data frame should be transmitted with protection");
+    NS_TEST_EXPECT_MSG_NE(
+        +psduIt->phyId,
+        +m_mainPhyId,
+        "RTS before last QoS data frame should not be transmitted by the main PHY");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
+                          m_auxPhyChannelWidth,
+                          "RTS before last data frame transmitted on an unexpected width");
+    psduIt++;
+    // CTS
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "CTS before last QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsCts(),
+                          true,
+                          "CTS before last QoS data frame has not been transmitted");
+    psduIt++;
+    // QoS Data
+    NS_TEST_ASSERT_MSG_EQ((psduIt != m_txPsdus.cend()),
+                          true,
+                          "Last QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->psduMap.cbegin()->second->GetHeader(0).IsQosData(),
+                          true,
+                          "Last QoS data frame has not been transmitted");
+    NS_TEST_EXPECT_MSG_EQ(+psduIt->phyId,
+                          +m_mainPhyId,
+                          "Last QoS data frame should be transmitted by the main PHY");
+    NS_TEST_EXPECT_MSG_EQ(psduIt->txVector.GetChannelWidth(),
+                          m_auxPhyChannelWidth,
+                          "Last data frame not transmitted on the same width as RTS");
+}
+
+EmlsrLinkSwitchTest::EmlsrLinkSwitchTest(const Params& params)
     : EmlsrOperationsTestBase(std::string("Check EMLSR link switching (switchAuxPhy=") +
-                              std::to_string(switchAuxPhy) +
-                              ", resetCamState=" + std::to_string(resetCamState) +
-                              ", auxPhyMaxChWidth=" + std::to_string(auxPhyMaxChWidth) + "MHz )"),
-      m_switchAuxPhy(switchAuxPhy),
-      m_resetCamState(resetCamState),
-      m_auxPhyMaxChWidth(auxPhyMaxChWidth),
+                              std::to_string(params.switchAuxPhy) +
+                              ", resetCamState=" + std::to_string(params.resetCamState) +
+                              ", auxPhyMaxChWidth=" + std::to_string(params.auxPhyMaxChWidth) +
+                              "MHz )"),
+      m_switchAuxPhy(params.switchAuxPhy),
+      m_resetCamState(params.resetCamState),
+      m_auxPhyMaxChWidth(params.auxPhyMaxChWidth),
       m_countQoSframes(0),
       m_txPsdusPos(0)
 {
